Package org.spongepowered.asm.logging

## Interface ILogger

All Known Implementing Classes:
  `LoggerAdapterAbstract`, `LoggerAdapterConsole`, `LoggerAdapterDefault`, `LoggerAdapterJava`

    public interface ILogger

Interface extracted from Log4j2's Logger (`org.apache.logging.log4j.Logger` ) with only the main methods used by Mixin included. This is to facilitate the delegation of logging to mixin services, and to sever the dependency on log4j2 from Mixin's core.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `catching​(java.lang.Throwable t)` Logs an exception or error that has been caught.
`void` `catching​(Level level, java.lang.Throwable t)` Logs an exception or error that has been caught.
`void` `debug​(java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the `DEBUG` level.
`void` `debug​(java.lang.String message, java.lang.Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` `error​(java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the `ERROR` level
`void` `error​(java.lang.String message, java.lang.Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` `fatal​(java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the `FATAL` level.
`void` `fatal​(java.lang.String message, java.lang.Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`java.lang.String` `getId()` Get the id of this logger
`java.lang.String` `getType()` Get a short human-readable name of this logger type
`void` `info​(java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the `INFO` level.
`void` `info​(java.lang.String message, java.lang.Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` `log​(Level level, java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the given level.
`void` `log​(Level level, java.lang.String message, java.lang.Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`<T extends java.lang.Throwable> T` `throwing​(T t)` Logs an exception or error to be thrown.
`void` `trace​(java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the `TRACE` level.
`void` `trace​(java.lang.String message, java.lang.Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` `warn​(java.lang.String message, java.lang.Object... params)` Logs a message with parameters at the `WARN` level.
`void` `warn​(java.lang.String message, java.lang.Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

### Method Detail

#### getId

    java.lang.String getId()

Get the id of this logger

#### getType

    java.lang.String getType()

Get a short human-readable name of this logger type

#### catching

    void catching​(Level level,
                  java.lang.Throwable t)

Logs an exception or error that has been caught.

Parameters:
  `level` - The logging Level.
  `t` - The Throwable.

#### catching

    void catching​(java.lang.Throwable t)

Logs an exception or error that has been caught.

Parameters:
  `t` - The Throwable.

#### debug

    void debug​(java.lang.String message,
               java.lang.Object... params)

Logs a message with parameters at the `DEBUG` level.

Parameters:
  `message` - the message to log
  `params` - parameters to the message

#### debug

    void debug​(java.lang.String message,
               java.lang.Throwable t)

Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `message` - the message to log
  `t` - the exception to log, including its stack trace

#### error

    void error​(java.lang.String message,
               java.lang.Object... params)

Logs a message with parameters at the `ERROR` level

Parameters:
  `message` - the message to log
  `params` - parameters to the message

#### error

    void error​(java.lang.String message,
               java.lang.Throwable t)

Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `message` - the message object to log
  `t` - the exception to log, including its stack trace

#### fatal

    void fatal​(java.lang.String message,
               java.lang.Object... params)

Logs a message with parameters at the `FATAL` level.

Parameters:
  `message` - the message to log
  `params` - parameters to the message

#### fatal

    void fatal​(java.lang.String message,
               java.lang.Throwable t)

Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `message` - the message object to log
  `t` - the exception to log, including its stack trace

#### info

    void info​(java.lang.String message,
              java.lang.Object... params)

Logs a message with parameters at the `INFO` level.

Parameters:
  `message` - the message to log
  `params` - parameters to the message

#### info

    void info​(java.lang.String message,
              java.lang.Throwable t)

Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `message` - the message object to log
  `t` - the exception to log, including its stack trace

#### log

    void log​(Level level,
             java.lang.String message,
             java.lang.Object... params)

Logs a message with parameters at the given level.

Parameters:
  `level` - the logging level
  `message` - the message to log
  `params` - parameters to the message

#### log

    void log​(Level level,
             java.lang.String message,
             java.lang.Throwable t)

Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `level` - the logging level
  `message` - the message to log
  `t` - the exception to log, including its stack trace

#### throwing

    <T extends java.lang.Throwable> T throwing​(T t)

Logs an exception or error to be thrown.

Type Parameters:
  `T` - the Throwable type
Parameters:
  `t` - The Throwable
Returns:
  the Throwable

#### trace

    void trace​(java.lang.String message,
               java.lang.Object... params)

Logs a message with parameters at the `TRACE` level.

Parameters:
  `message` - the message to log
  `params` - parameters to the message

#### trace

    void trace​(java.lang.String message,
               java.lang.Throwable t)

Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `message` - the message object to log
  `t` - the exception to log, including its stack trace

#### warn

    void warn​(java.lang.String message,
              java.lang.Object... params)

Logs a message with parameters at the `WARN` level.

Parameters:
  `message` - the message to log
  `params` - parameters to the message

#### warn

    void warn​(java.lang.String message,
              java.lang.Throwable t)

Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

Parameters:
  `message` - the message object to log
  `t` - the exception to log, including its stack trace